function [f1,f2,t1,t2,gammabest,iter,Ecc,Ec,minE,clsd_crve,whch_crve,drct_crve,strt_crve,R] = ESD_comp_alldim(stage,iten,space,itop,both_drct,b1,b2,varargin)
%function [minE,clsd_crve,whch_crve,drct_crve] = ESD_comp_alldim(both_drct,b1,b2,t1,t2)

% both_drct = for dertermining whethere one of the curves is to be
% considered in the reversed direction (0 if no, 1 if yes)
%
% clsd_crve = number of curves that are closed (0, 1 or 2)
% whch_crve = if only one curve is closed, which curve it is (1 or 2)
% drct_crve = curve 1 direction for optimality (1 [as given] -1 [counter])
% strt_crve = optimal starting point of first closed curve if any
% R = optimal rotation
%
clsd_crve = 0;
whch_crve = 0;
drct_crve = 1;

[n1,N1] = size(b1);
[n2,N2] = size(b2);
if n1 ~= n2
   error('Curves must be in the same d-dimensional space');
end

if b1(:,end) == b1(:,1)
   clsd_crve = clsd_crve + 1;
   whch_crve = 1;
end
if b2(:,end) == b2(:,1);
   clsd_crve = clsd_crve + 1;
   whch_crve = 2;
end

if clsd_crve ~= 2 && stage == 3
%   if clsd_crve == 1
      stage = 2;
%   else
%      stage = 1;
%   end
%   fprintf('\n Level of methodology changed to %2.0f \n', stage);
end

del1(1) = 0;
for r = 2:N1
   del1(r) = norm(b1(:,r) - b1(:,r-1));
end
len1= sum(del1);

del2(1) = 0;
for r = 2:N2
   del2(r) = norm(b2(:,r) - b2(:,r-1));
end
len2= sum(del2);

if isempty(varargin)
%  if clsd_crve == 0 || (n1 == 1 && stage == 1)
   if clsd_crve == 0
      t1 = cumsum(del1)/len1;
      t1(1) = 0;
      t1(N1) = 1;

      t2 = cumsum(del2)/len2;
      t2(1) = 0;
      t2(N2) = 1;
   else
      t1 = linspace(0,1,N1);
      t2 = linspace(0,1,N2);
   end
else
   t1 = varargin{1};
   t2 = varargin{2};
   if length(t1) ~= N1
      error('Length of t values for curve 1 seems incorrect');
   end
   if length(t2) ~= N2
      error('Length of t values for curve 2 seems incorrect');
   end
end

if n1 == 1

%  if (clsd_crve == 0 || stage == 1)
   if clsd_crve == 0
      f1 = b1/len1;
      f2 = b2/len2;
   else
      T = N1;
      if N2 > T   T = N2; end


      [f1,len1] = ReSampleCurve(t1,b1,T);
      [f2,len2] = ReSampleCurve(t2,b2,T);

      f1 = f1/len1;
      f2 = f2/len2;

      t1 = linspace(0,1,T);
      t2 = t1;
   end

else

   if clsd_crve == 0
      [f1,f2,t] = parameterize_curve_pair(b1,b2,t1,t2);

      f1 = f1/len1;
      f2 = f2/len2;

      t1 = t;
      t2 = t;
   else
      T = N1;
      if N2 > T   T = N2; end

      [f1,len1] = ReSampleCurve(t1,b1,T);
      [f2,len2] = ReSampleCurve(t2,b2,T);

      f1 = f1/len1;
      f2 = f2/len2;

      t1 = linspace(0,1,T);
      t2 = t1;
   end
end
%
scl = space;

if clsd_crve == 0
   scl = 0;
   [gammabest,iter,Ecc,Ec,minE,strt_crve,R] = ESD_core_alldim(stage,iten,scl,itop,f2,f1,t2,t1);
elseif clsd_crve == 2
   [gammabest,iter,Ecc,Ec,minE,strt_crve,R] = ESD_core_alldim(stage,iten,scl,itop,f2,f1,t2,t1);
else
   if whch_crve == 1
      [gammabest,iter,Ecc,Ec,minE,strt_crve,R] = ESD_core_alldim(stage,iten,scl,itop,f2,f1,t2,t1);
   else
      [gammabest,iter,Ecc,Ec,minE,strt_crve,R] = ESD_core_alldim(stage,iten,scl,itop,f1,f2,t1,t2);
   end
end

if(both_drct)

   [n1,N1] = size(f1);

   for i=1:N1
      f1c(:,i) = f1(:,N1-i+1);
      if clsd_crve == 0
         t1c(i) = 1 - t1(N1-i+1);
      else
         t1c(i) = t1(i);
      end
   end

   scl = space;

   if clsd_crve == 0
      scl = 0;
      [gammacest,itec,Fcc,Fc,minc,strt_crvc,Rc] = ESD_core_alldim(stage,iten,scl,itop,f2,f1c,t2,t1c);
   elseif clsd_crve == 2
      [gammacest,itec,Fcc,Fc,minc,strt_crvc,Rc] = ESD_core_alldim(stage,iten,scl,itop,f2,f1c,t2,t1c);
   else
      if whch_crve == 1
         [gammacest,itec,Fcc,Fc,minc,strt_crvc,Rc] = ESD_core_alldim(stage,iten,scl,itop,f2,f1c,t2,t1c);
      else
         [gammacest,itec,Fcc,Fc,minc,strt_crvc,Rc] = ESD_core_alldim(stage,iten,scl,itop,f1c,f2,t1c,t2);
      end
   end

   if minc < minE
      drct_crve = -1;
      f1 = f1c;
      t1 = t1c;
      gammabest = gammacest;
      iter = itec;
      Ecc = Fcc;
      Ec = Fc;
      minE = minc;
      strt_crve = strt_crvc;
      R = Rc;
   end

end

%fprintf('\n f1(1,1), f1(2,1) = %5.1f %5.1f \n', f1(1,1), f1(2,1));
%fprintf('\n f1(1,n), f1(2,n) = %5.1f %5.1f \n', f1(1,n), f1(2,n));
%pause

