function [h] = rotation_weights(q1,q2,varargin)

[n,T] = size(q1);
[n2,T2] = size(q2);
if n ~= n2
   error('Curves must be in the same d-dimensional space');
end
if T ~= T2
   error('Curves must have the same number of nodes');
end

if isempty(varargin)
   dt = 1/(T-1);
   h(1) = dt/2;
   h(T) = dt/2;
   for l = 2:T-1
       h(l) = dt;
   end
else
   t = varargin{1};
   if length(t) ~= T
      error('Length of t must be equal to number of nodes in each curve');
   end
   h(1) = (t(2)-t(1))/2;
   h(T) = (t(T)-t(T-1))/2;
   for l = 2:T-1
       h(l) = (t(l+1)-t(l-1))/2;
   end
end

